
#include <Servo.h>                     
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();
#define SERVO_FREQ 50
//объявляем входы к ним подключаем наш RC с 1 по 6 канал
int kanal1 = 10;
int kanal2 = 11;
int kanal3 = 7;
int kanal4 = 8;
int kanal5 = 12;
int kanal6 = 13;

// переменные для записи сигнала
int sig1;
int sig2;
int sig3;
int sig4;
int sig5;
int sig6;
// переменные для управелния ШИМ
int shim1;
int shim2;
int shim3;
int shim4;
int shim5;
int shim6;

// Двигатель A
int enA = 2;
int in1 = 5;
int in2 = 3;
// Двигатель B
int enB = 4;
int in3 = 6;
int in4 = 9;

#define myservo1 0
#define myservo2 1
#define myservo3 2
#define myservo4 3


int speet = 0;
int servo = 0;
int servo1 = 0;
int servo2 = 0;
int servo3 = 0; 
int servo4 = 0;
int val = 0;
int val1 = 0;
int val2 = 0;
int pulsin = 5;


void setup()
{
  Serial.begin(9600);
  pwm.begin();               
  pwm.setPWMFreq(60);                  
 pwm.setOscillatorFrequency(27000000);
   pwm.setPWMFreq(SERVO_FREQ);
  // назначаем пины как входы
  pinMode(kanal1, INPUT);
  pinMode(kanal2, INPUT);
  pinMode(kanal3, INPUT);
  pinMode(kanal4, INPUT);
  pinMode(kanal5, INPUT);
  pinMode(kanal6, INPUT);
  // назначаем пины как выходы
  pinMode(enA, OUTPUT);
  pinMode(enB, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);

   pwm.setPWM(myservo1, 0, degr(170));
   pwm.setPWM(myservo2, 0, degr(0));
   pwm.setPWM(myservo3, 0, degr(90));
   pwm.setPWM(myservo4, 0, degr(40));

}

void loop()
{
  // записываем показания приемника
  sig1 = pulseIn(kanal1, HIGH);
  sig2 = pulseIn(kanal2, HIGH);
  sig3 = pulseIn(kanal3, HIGH);
  sig4 = pulseIn(kanal4, HIGH);
  sig5 = pulseIn(kanal5, HIGH);
  sig6 = pulseIn(kanal6, HIGH);

  // вычисляем значение ШИМ
  shim1 = (sig1 - 990) / 4.2;
  shim2 = (sig2 - 990) / 4.2;
  shim3 = (sig3 - 990) / 4.2;
  shim4 = (sig4 - 990) / 4.2;
  shim5 = (sig5 - 990) / 4.2;
  shim6 = (sig6 - 990) / 4.2;

Serial.println();
  
    Serial.print("1");
    Serial.print(": ");
    Serial.print(shim1);
    Serial.print("    ");
    
    Serial.print("2");
    Serial.print(": ");
    Serial.print(shim2);
    Serial.print("    ");
    
    Serial.print("3");
    Serial.print(": ");
    Serial.print(shim3);
    Serial.print("    ");

    Serial.print("4");
    Serial.print(": ");
    Serial.print(shim4);
    Serial.print("    ");

     Serial.print("5");
    Serial.print(": ");
    Serial.print(shim5);
    Serial.print("    ");

     Serial.print("6");
       Serial.print(": ");
    Serial.print(shim6);
    Serial.print("    ");


  ////  УПАВЛЕНИЕ РОБОТОМ  /////
  if (shim6 <= 105) {
    speet = map(shim3, 0, 234, 0, 255);
    if (shim2 >= 180 ) {
      pered();
      delay(1);
    }

    if (shim1 >= 190) {
      pravo();
     delay(1);
    }
    
    if (shim2 <= 10) {
    zad();
    delay(1);
    }

    if ( shim1 <= 10) {
      levo();
      delay(1);
    }

    if (shim3 <= 5 || shim2 >= 100 && shim2 <= 120 || shim1 >= 100 && shim1 <= 120) {
      red(0, 0);
      delay(1);
    }
  }


                 ///  УПРАВЛЕНИЕ КЛЕШНЁЙ  ////
if (shim6 >= 110 && shim6 <= 250) {
    red(0, 0);
    

if (shim4 >= 180 && shim4 <= 234) {
      val = val + pulsin;
       pwm.setPWM(myservo1, 0, degr(val));
     
}

if (shim4 <= 10) {
      val = val - pulsin;
      pwm.setPWM(myservo1, 0, degr(val));
      
}

if (shim2 >= 180 && shim2 <= 250) {
      val1 = val1 + pulsin;
       pwm.setPWM(myservo2  , 0, degr(val1));
      
}

if (shim2 <= 10) {
      val1 = val1 - pulsin;
      pwm.setPWM(myservo2, 0, degr(val1));
      
}


if (shim1 >= 190 && shim1 <= 234) {
      val2 = val2 - pulsin;
      pwm.setPWM(myservo3, 0, degr(val2));
      
}


    if (shim1 <= 10 ) {
      val2 = val2 + pulsin;
     pwm.setPWM(myservo3, 0, degr(val2));
      
}

    if (shim6 >= 120 && shim6 <= 150) {
      pwm.setPWM(myservo4, 0, degr(40));
      
    }

    if (shim6 >= 200 && shim6 <= 250) {
      pwm.setPWM(myservo4, 0, degr(100));
      
    }

}



}

int degr(int gradus) {
  int popugai = map(gradus, 0, 180, 150, 600);
  return popugai;
  }

int levo() {
  digitalWrite(enA, 1);
  digitalWrite(enB, 1);
  analogWrite(in1, 0);
  analogWrite(in2, speet);
  analogWrite(in3, 0);
  analogWrite(in4, speet);

}


int pered() {
  digitalWrite(enA, 1);
  digitalWrite(enB, 1);
  analogWrite(in1, 0);
  analogWrite(in2, speet);
  analogWrite(in3, speet);
  analogWrite(in4, 0);


}


int zad() {
  digitalWrite(enA, 1);
  digitalWrite(enB, 1);
  analogWrite(in1, speet);
  analogWrite(in2, 0);
  analogWrite(in3, 0);
  analogWrite(in4, speet);

}

int pravo() {
  digitalWrite(enA, 1);
  digitalWrite(enB, 1);
  analogWrite(in1, speet);
  analogWrite(in2, 0);
  analogWrite(in3, speet);
  analogWrite(in4, 0);

}



int red(int r, int r1) {
  digitalWrite(enA, 0);
  digitalWrite(enB, 0);



}
